#!/bin/sh
#          
#     /home   .  
#       :))  ,    !
#  -      ,    
#   .      
#
# Author:           php-coder <php-coder@ngs.ru>
# Date:              22.08.2004
# Last update: 05.09.2004
#
#    /    $BACKUP_LIST 
#  $BACKUP_DIR.     , 
#   '#' ,   $BACKUP_LIST .  ,
# $BACKUP_DIR    
# .       ,  md5-
#      .    
#        
#   ,   .
#
# TODO:
# -    ,   $? > 0
# -    ,   
#
# Enjoy! :))
#

# ,      
BACKUP_DIR=/mnt/other/backup

#    ,    
#  
BACKUP_LIST=/home/coder/backup.list

#        .
#    -,      , 
#      
FD=/dev/stdout
FDERR=/dev/stderr

#        ,    -c
RECIPIENT=root@mycomp.mydomain

# --------------------------------------------------------------------
# ,      ,  
#     
# --------------------------------------------------------------------
function create_copy
{
 #        
 BACKUP_PATH=$BACKUP_DIR`dirname "$1"`

 #       
 BACKUP_FILE=$BACKUP_DIR$1

 #  -      , 
 if [ ! -d "$BACKUP_PATH" ]; then
    #  ,    
    echo -n " " $BACKUP_PATH"..." >> $FD
    mkdir -p "$BACKUP_PATH" && echo "  OK" >> $FD
    #   ,     
    echo -n "   " $1"..." >> $FD
    cp -p "$1" "$BACKUP_PATH" && echo "  OK" >> $FD
    #        
    continue
 fi

 #     , 
 if [ -f "$BACKUP_FILE" ]; then
    #  md5  -  -
    local MD5_ORIG=`md5sum "$1" | awk '{print $1}'`
    local MD5_COPY=`md5sum "$BACKUP_FILE" | awk '{print $1}'`
    #   
    if [ $MD5_ORIG = $MD5_COPY ]; then
       #   ,     
       continue
    else
       #    
       echo -n "   " $1"..." >> $FD
       cp -pf "$1" "$BACKUP_PATH" && echo "  OK" >> $FD
       #        
       continue
    fi
#      , 
 else
    #   ,     
    echo -n "   " $1"..." >> $FD
    cp -p "$1" "$BACKUP_PATH" && echo "  OK" >> $FD
    #        
    continue
 fi
}
# --------------------------------------------------------------------

#   ,     
#      ,    -
TMPFILE=`mktemp -q` || TMPFILE=$TMPDIR/make_backup.sh.$$.`date +%s`

#    
while getopts ":cd:l:" CMD_OPTION
do
  case $CMD_OPTION in
    c)
      #    -,      
      #       
      FD=$TMPFILE
      FDERR=$TMPFILE
      #  ,     
      SEND_LETTER=yes
      ;;
    d)
      #    -d,    $BACKUP_DIR
      BACKUP_DIR=$OPTARG
      ;;
    l)
      #    -l,    $BACKUP_LIST
      BACKUP_LIST=$OPTARG
      ;;
    ?)
      echo -n "     !" >> $FDERR
      echo ",         !" >> $FDERR
      ;;
  esac
done

#         
#    ,      
if [ ! -f "$BACKUP_LIST" ]; then
   echo "" $BACKUP_LIST " !" >> $FDERR
   exit 1
fi

#      ,     ,
#       
if [ ! -s "$BACKUP_LIST" ]; then
   echo "" $BACKUP_LIST "!" >> $FDERR
   exit 2
fi

if [ ! -r "$BACKUP_LIST" ]; then
   echo "      " $BACKUP_LIST"!" >> $FDERR
   exit 3
fi

#          ,
#      
if [ ! -w "$BACKUP_DIR" ]; then
   echo "       " $BACKUP_DIR"!" >> $FDERR
   exit 4
fi

#    $BACKUP_LIST,     .
#     
grep -e '^[^(#|$)]' "$BACKUP_LIST" |
while read FILE;
do
  #        , 
  if [ -f "$FILE" ]; then
     #   :))
     create_copy "$FILE"
  fi

  #          , 
  if [ -d "$FILE" ]; then
     #            
     find "$FILE" -type f -print |
     while read FILE_F;
     do
       #      
       create_copy "$FILE_F"
     done
    #      
    continue
  fi

  #       ,   ,    
  echo "! " $FILE "       !" >> $FDERR

  #     
  continue
done

#    -, 
if [ -n "$SEND_LETTER" ]; then

   #     
   if [ ! -s "$TMPFILE" ]; then
      #  ,       
      echo "       ..." > "$TMPFILE"
   fi

   #       
   mail -s "Backup  `date '+%d.%m.%Y %T'`" $RECIPIENT < "$TMPFILE"
fi

#   ,       
rm -f "$TMPFILE"
